import * as React from 'react';
import { Effects, Store } from '..';
import { Diff } from '../utils';
export declare type Connect<State extends object> = {
    Container: React.ComponentType<ContainerProps<State>>;
    withStore: <Props extends {
        store: Store<State>;
    }>(Component: React.ComponentType<Props>) => React.ComponentType<Diff<Props, {
        store: Store<State>;
    }>>;
};
export declare type ContainerProps<State extends object> = {
    effects?: Effects<State>;
    initialState?: State;
};
export declare function createConnectedStore<State extends object>(initialState: State, effects?: Effects<State>): Connect<State>;
